﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Samples.GridView.RowReorder;
using System.Collections.ObjectModel;
using System.Collections;

namespace WPF.RowReorder
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var collection = new ObservableCollection<SampleClass>(from c in Enumerable.Range(0, 10) select new SampleClass { ID = c, Name = "Name" + c });
            this.DataContext = collection;
        }

        private void RowReorderBehavior_DragEnded(object sender, DragEndedEventArgs e)
        {
            //add your logic here
            MessageBox.Show(string.Format("Drop complete! Index: {0}", e.DestinationIndex));

            //some sample logic
            var items = ((IList)e.SourceGrid.ItemsSource);

            using (e.SourceGrid.Items.DeferRefresh())
            {
                foreach (var item in e.DraggedItems)
                {
                    items.Remove(item);
                }

                foreach (var item in e.DraggedItems)
                {

                    if (e.DestinationIndex < items.Count)
                    {
                        items.Insert(e.DestinationIndex, item);
                    }
                    else
                    {
                        items.Add(item);
                    }
                }
            }

            e.SourceGrid.Rebind();
        }

    }

    public class SampleClass
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }
}
